;;;;;;;;;; /Users/iam/Repositories/NPA/Package/launcher.lsp autogenerated on  Thu Apr 13 10:18:07 2017 ;;;;;;;;;;
;;;;;;;;;; Tools/makeg2dlib loaded JLibrary/npadebug.lsp ;;;;;;;;;;

(define npa_debug (boolean true))

(define logDev (msg) 
  (if npa_debug
      (invoke java.lang.System.err "println" msg))
  )

(invoke java.lang.System.err "println" (concat "\nNPA: npa_debug = " npa_debug))

;;;;;;;;;; Tools/makeg2dlib loaded JLibrary/graphviz.lsp ;;;;;;;;;;
;;new in November 2013 (for use in NPA and CTA too)
;;please keep this file in synch with the one in IOP
;;enforce a reasonably recent dot

(define dot_required_version (int 2))
(define dot_required_major (int 26))
(define dot_required_minor (int 0))

(define showDotPopup ()
  (let (
        (url "http://light.csl.sri.com/plaonline/graphviz.html")
        (preferred (object ("java.awt.Dimension" (int 500) (int 300))))
        (popup (object ("g2d.swing.HTMLPopup" "Graphviz Needed"  url preferred)))
        )
    (invoke popup "display")
    )
  )

(define checkGraphviz  ()
  (let (
        (version  g2d.graph.Dot.VERSION)
        )
    (if (isnull version)
        (seq 
         (invoke java.lang.System.err "println" (concat "\n\nChecking dot: NO VERSION FOUND\n\n"))
         (apply showDotPopup)
         (throw (object ("java.lang.RuntimeException" "You need to install graphviz")))
         )
      (invoke java.lang.System.err "println" (concat "\n\nChecking dot: found version " version "\n\n"))
      )

    (let (
          (version_no  (lookup version "version"))
          (version_major  (lookup version "major"))
          (version_minor  (lookup version "minor"))
          )
      (if (or (< version_no dot_required_version)
              (and (= version_no dot_required_version) 
                   (< version_major dot_required_major))
              (and (= version_no dot_required_version) 
                   (= version_major dot_required_major)
                   (< version_minor dot_required_minor)))
          (seq 
           (apply showDotPopup)
           (throw (object ("java.lang.RuntimeException" (concat "Your dot version: " version " is too old"))))
           )
        )
      )
    )
  )


(if  (and (not (sinvoke "g2d.Main" "isRemote")) (not (sinvoke "g2d.Main" "isGadget")))
    (apply checkGraphviz))


;;;;;;;;;; Tools/makeg2dlib loaded JLibrary/launcher_base.lsp ;;;;;;;;;;


(if (not (not npa_debug))
    (seq
     (sinvoke "g2d.jlambda.Debugger" "toggleVerbosity")
     (sinvoke "g2d.jlambda.Debugger" "setStackDepth" (int 3))
     )
  )

(define examplesRoot (object ("java.io.File" "lib" "examples")))

(define protocolsRoot (object ("java.io.File" "protocols")))

(define templateRoot (object ("java.io.File" protocolsRoot "Template")))

(define templateFileNames
  (array java.lang.String
         "input.txt"
         "load-npa-assist-genGrammar.maude"
         "load-npa-assist.maude"
         "run_npa"
         "run_npa_gen"
         "startup-genGrammar.txt"
         "startup.txt"
         )
  )

(define preferences g2d.npa.NPAFrame.npaPreferences)

(define setStatus (status msg)
  (if (isobject msg)
      (invoke status "setText" msg)))

(define newDirectoryName (path name)
  (apply newDirectoryNameAux path name name (int 0)))

(define newDirectoryNameAux (path orig current index)
  (let ((file (object ("java.io.File" path current))))
    (if (not (invoke file "exists"))
        (seq (invoke file "mkdir") file)
      (apply newDirectoryNameAux path orig (concat orig index) (+ index (int 1)))
      )
    )
  )

;(apply newDirectoryName "protocols" "NSPK")

(define launchIOP (directory startup)   
  (let (
        (args (if npa_debug
		  (array java.lang.String  "iop"  "-i" startup)
		(array java.lang.String  "iop"  "-n" "-i" startup)))
        (pb (object ("java.lang.ProcessBuilder" args)))
        (env (invoke pb "environment"))
        )
    (seq
     (apply logDev (concat "launchIOP directory=" directory " startup=" startup))
     (invoke pb "directory" directory)
     (invoke pb "start")
     )
    )
  )

;(apply launchIOP (object ("java.io.File" "protocols" "NSPK")) "startup.txt")

(define toArray (arraylist)
  (let (
        (len (invoke arraylist "size"))
        (a (mkarray java.lang.String len)) 
        )
    (invoke arraylist "toArray" a)
    )
  )

(define stripMaudeExtension (name)
  (let  (
         (dot (invoke name "lastIndexOf" (char '.')))
         (basename (invoke name "substring" (int 0) dot))
         )
    basename
    )
  )


(define listMaudeFiles (path)
  (let (
        (candidates  (invoke path "listFiles"))
        (actuals (object ("java.util.ArrayList")))
        )
    (seq
     (if (isobject candidates)
	 (for candidate candidates
	      (let ((name (invoke candidate "getName")))
		(if (invoke name "endsWith" ".maude")
		    (invoke actuals "add"  (apply stripMaudeExtension name))
		  )
		)
	      )
       )
     (apply toArray actuals)
     )
    )
  )


; (apply listMaudeFiles examplesRoot)

(define listProtocols (path)
  (let (
        (candidates  (invoke path "listFiles"))
        (actuals (object ("java.util.ArrayList")))
        )
    (seq
     (for candidate candidates
          (if (invoke candidate "isDirectory")
              (let ((name (invoke candidate "getName")))
                (if (and (not (invoke name "equals" ".svn"))
                         (not (invoke name "equals" "Template")))
                    (invoke actuals "add"  name)
                  )
                )
            )
          )
     (apply toArray actuals)
     )
    )
  )


;; (apply listProtocols protocolsRoot)

;;(apply protocolLauncher value)

(define listDoubleClicker (list)
  (let ((mec (object ("g2d.closure.ClosureMouseListener")))
	(mec2c (lambda (self event)
		 (if (= (invoke event "getClickCount") (int 2))
		     (let ((selected (invoke list "getSelectedValue")))
		       (if (isobject selected)
			   (seq
			    (invoke list "clearSelection")
			    (apply protocolLauncher selected)
			    )
			 )
		       )))))
    (invoke mec "setMouseAction" java.awt.event.MouseEvent.MOUSE_CLICKED mec2c)
    (invoke list "addMouseListener" mec)
    )
  )

(define mkListTab (list closureMaker doubleclick html)
  (let ((tab (object ("javax.swing.JPanel" (object ("java.awt.BorderLayout")))))
        (south (object ("javax.swing.JPanel" (object ("java.awt.BorderLayout")))))
        (status (object ("javax.swing.JLabel" "")))
        (buttons (object ("javax.swing.JPanel")))
        (launch (object ("javax.swing.JButton" "Launch")))
        (launchAction (apply closureMaker launch list status))
        (selectionListener (apply selectionListenerMaker launch list status))
        (helper_title "NPA Help")
	(helper_src  (object ("java.io.File" "libgui/html/" html)))
	(helper (object ("g2d.launcher.Helper" helper_title helper_src)))
        (help (lookup helper "help"))
        )
    (seq
     (invoke list "setSelectionMode" javax.swing.ListSelectionModel.SINGLE_SELECTION)
     (invoke list "addListSelectionListener" selectionListener)
     (if doubleclick (apply listDoubleClicker list))
     (invoke buttons "add" help)
     (invoke buttons "add" launch)
     (invoke launch "addActionListener" launchAction)
     (invoke launch "setEnabled" (boolean false))
     (invoke south "add" buttons java.awt.BorderLayout.EAST)
     (invoke tab "add" south java.awt.BorderLayout.SOUTH)
     (invoke tab "add" (object ("javax.swing.JScrollPane" list)) java.awt.BorderLayout.CENTER)
     (invoke tab "add" status java.awt.BorderLayout.NORTH)
     (apply setStatus status "Select a protocol  to continue")
     tab
     )
    )
  )

(define updateProtocolList  (frame protocolList)
  (let (
        (model (invoke protocolList "getModel"))
        (protocols (apply listProtocols protocolsRoot))
        )
    (seq 
     (invoke model "clear")
     (for protocol protocols (invoke model "addElement" protocol))
     (invoke frame "repaint")
     )
    )
  )


(define chooseAction 
  (lambda (frame launch storage status)
    (let (
          (closure 
           (lambda (self event) 
             (let (
                   ;;(chooser (object ("javax.swing.JFileChooser")))
                   (chooser (object ("g2d.util.FileChooser")))
                   (extensions (array java.lang.String "maude" "m"))
                   (filter  (object ("javax.swing.filechooser.FileNameExtensionFilter" "Maude Protocol File" extensions)))
                   )
             (seq 
              (invoke g2d.npa.NPAFrame.npaPreferences "manageFileChooser" chooser "userDefined")
              (invoke chooser "setFileFilter" filter)
              (let ((retval (invoke chooser "showOpenDialog" frame)))
                (if (= retval javax.swing.JFileChooser.APPROVE_OPTION)
                    (let (
                          (file (invoke chooser "getSelectedFile"))
                          (name (invoke file "getName"))
                          )
                      (seq
                       (apply setStatus status  (concat "Choosing:" name))
                       (setattr storage "file" file)
                       (setattr storage "name" name)
                       (invoke launch "setEnabled" (boolean true))
                       )
                      )
                  (apply setStatus status  (concat "Choosing NOT!"))
                  )
                )
              )
             )
             )
           )
          )
      (object ("g2d.closure.ClosureActionListener" closure)))
    )
  )

(define userLaunchActionMaker
    (lambda (launch storage status launchClosure)
      (let (
            (closure 
             (lambda (self event) 
               (let (
                     (file (getattr storage "file"))
                     (name (getattr storage "name"))
                     )
                 (seq 
                  (invoke launch "setEnabled" (boolean false))
                  (apply setStatus status  (concat "Launching: " name " please be patient!"))
                  (apply launchClosure (invoke file "getParent") file name status)
                  ))))
            )
        (object ("g2d.closure.ClosureActionListener" closure)))
      )
    )


(define mkUserTab (frame launchClosure html)
  (let ((tab (object ("javax.swing.JPanel" (object ("java.awt.BorderLayout")))))
        (south (object ("javax.swing.JPanel" (object ("java.awt.BorderLayout")))))
        (storage (object ("g2d.jlambda.Attributable")))
        (status (object ("javax.swing.JLabel" "")))
        (buttons (object ("javax.swing.JPanel")))
        (launch (object ("javax.swing.JButton" "Launch")))
        (launchAction (apply userLaunchActionMaker launch storage status launchClosure))
        (choose (object ("javax.swing.JButton" "Choose Protocol File")))
        (helper_title "NPA Help")
	(helper_src  (object ("java.io.File" "libgui/html/" html)))
	(helper (object ("g2d.launcher.Helper" helper_title helper_src)))
        (help (lookup helper "help"))
        )
    (seq
     (invoke choose "addActionListener" (apply chooseAction frame launch storage status))
     (invoke buttons "add" help)
     (invoke buttons "add" choose)
     (invoke buttons "add" launch)
     (invoke launch "addActionListener" launchAction)
     (invoke launch "setEnabled" (boolean false))
     (invoke south "add" buttons java.awt.BorderLayout.EAST)
     (invoke tab "add" south java.awt.BorderLayout.SOUTH)
     (invoke tab "add" status java.awt.BorderLayout.NORTH)
     tab
     )
    )
  )


(define protocolLauncher 
  (lambda (value) 
    (let ((target (object ("java.io.File" protocolsRoot value))))
      (seq 
       (apply launchIOP target "startup.txt")
       )
      )
    )
  )

(define exampleLauncherMaker
  (lambda (frame listProtocols)
    ;;exampleLauncher
    (lambda  (value) 
      (let (
            (fileName  (concat value ".maude"))
            (directory  (apply newDirectoryName protocolsRoot value))
            (protocolSrc (object ("java.io.File" examplesRoot fileName)))
            (protocolDest (object ("java.io.File" directory fileName)))
            )
        (seq
         (sinvoke "g2d.util.IO" "copyFile" protocolSrc protocolDest)
         (apply populateProtocol directory value)
         (apply updateProtocolList frame listProtocols)
         (apply launchIOP directory "startup-genGrammar.txt")
	 (apply logDev (concat "Launching example: " value))
	 )
	)
      )
    )
  )


(define userLauncherMaker 
  (lambda (frame listProtocols)
    ;;userDefinedLauncher
    (lambda  (directory file value status) 
      (let (
            (name (apply stripMaudeExtension value))
            (targetdir (apply newDirectoryName protocolsRoot name))
            (protocolDest (object ("java.io.File" targetdir value)))
            )
        (seq 
         (sinvoke "g2d.util.IO" "copyFile" file protocolDest)
         (apply populateProtocol targetdir name)
         (apply updateProtocolList frame listProtocols)
         (apply launchIOP targetdir "startup-genGrammar.txt")
         (apply setStatus status  (concat "Launching: in directory " targetdir ", Generating grammar: please be patient!"))
         )
        )
      )
    )
  )

(define populateProtocol (directory protocol)
  (for filename templateFileNames (apply populateProtocolAux directory protocol filename))
  )

(define populateProtocolAux (directory protocol file)
  (let (
        (fileSrc (object ("java.io.File" templateRoot file)))
        (fileDest (object ("java.io.File" directory file)))
        (contentsSrc (sinvoke "g2d.jlambda.Utils" "file2String" fileSrc))
        (contentsDest (invoke contentsSrc "replaceAll" "PROTOCOLNAME" protocol))
        )
    (seq 
     (sinvoke "g2d.util.IO" "string2File" contentsDest fileDest)
     )
    )
  )

(define actionClosureMaker 
  (lambda (launcher)
    (lambda (launch list status)
      (let (
            (closure 
             (lambda (self event) 
               (let ((value (invoke list "getSelectedValue")))
                 (seq 
                  (invoke launch "setEnabled" (boolean false))
                  (apply launcher value)
                  (invoke list "clearSelection")
                  (apply setStatus status  (concat "Launching: " value " please be patient!"))
                  ))))
            )
        (object ("g2d.closure.ClosureActionListener" closure)))
      )
    )
  )

(define selectionListenerMaker (launch list status)
  (let (
        (closure 
         (lambda (self event)
           (let ((value (invoke list "getSelectedValue")))
             (if (and (not (invoke event "getValueIsAdjusting"))
                      (isobject value))
                 (seq
                  (invoke launch "setEnabled" (boolean true))
                  (apply setStatus status (concat "Press \"Launch\" to study " value))
                  (apply logDev value)
		  )
	       )
             )
           )
         )
        (listener (object ("g2d.closure.ClosureListSelectionListener" closure)))
        )
    listener
    )
  )

(define launchFrame ()
  (let (
        (frame (object ("g2d.npa.NPAFrame" "NPA Launcher" "launcher")))
        (tabs  (object ("javax.swing.JTabbedPane")))
        (protocols (apply listProtocols protocolsRoot))
        (protocolsModel (object ("javax.swing.DefaultListModel")))
        (listProtocols (object ("javax.swing.JList" protocolsModel)))
        (tabProtocols  (apply mkListTab listProtocols (apply actionClosureMaker protocolLauncher) (boolean true) "protocols_help.html"))
        (examples (apply listMaudeFiles examplesRoot))
        (listExamples (object ("javax.swing.JList" examples)))
        (exampleLauncher (apply exampleLauncherMaker frame listProtocols))
        (tabExamples  (apply mkListTab listExamples (apply  actionClosureMaker exampleLauncher) (boolean false) "examples_help.html"))
        (userLauncher  (apply userLauncherMaker frame listProtocols))
        (tabUser  (apply mkUserTab frame userLauncher "user_defined_help.html"))
        )
    (seq
     (apply updateProtocolList frame listProtocols)
     (invoke tabs "addTab" "Protocols" tabProtocols)
     (invoke tabs "addTab" "Examples" tabExamples)
     (invoke tabs "addTab" "User Defined" tabUser)
     ;; this is for production
     (if (not npa_debug)
         (invoke frame "setDefaultCloseOperation" javax.swing.JFrame.EXIT_ON_CLOSE)
       )
     (invoke frame "add" tabs)
     (invoke frame "pack")
     (invoke frame "setVisible" (boolean true))
     )
    )
  )

(apply launchFrame)




